#By Ivani de Oliveria Negrao Lopes
#Tables used in this script are generated by the script: Files_Anova_Models.py

library(ScottKnott)
setwd("..")

species= c("bfl","cin","cbr","cel","aae","ame","api","bmo","dme","tca","aca","xtr","gga","cfa","eca","mdo","mml","ggo","hsa","ptr","oan","cgr","mmu","rno","bta","oar","ssc","dre","ola","ppt","aly","ath","mes","gma","mtr","lus","mdm","ppe","ptc","stu","vvi","bdi","osa","sbi","zma")
ModList = c("24","44")

for (m in 1:length(ModList)){
	for (spe in 1:length(species)){
		f=paste("Models/Accuracy_",ModList[m],"_",species[spe],".csv",sep="")
		Dat = read.csv(f,header = FALSE )
		M = as.factor(Dat$V1)
		blk = as.factor(Dat$V2)
		dm = data.frame(M,blk)
		y = data.frame(Dat$V3)

		dfm = data.frame(dm,y)

		nsk1 = with(dfm,SK(x=dm, y=y, model='y ~ blk + M', which='M'))
		out = capture.output(as.matrix((summary(nsk1))))

		f1 = paste("Models/Compare_",ModList[m],"_Models_for_",species[spe],".txt",sep='')
		write(out,file=f1,ncolumns = 2,sep="\n",append=F)
									}
							}
