#By Ivani de Oliveria Negrao Lopes
#Tables used in this script are generated by the script: Multispecies.py

library(ScottKnott)

setwd("..")

mainDir = getwd()
subDir = "Clusters"
if (!file.exists(subDir)){dir.create(file.path(mainDir, subDir))} 


alg <- c("SVM", "RF", "J48")
specie <- c('bfl', 'cin', 'aca', 'xtr', 'gga', 'cfa', 'eca', 'mdo', 'mml', 'ggo', 'hsa', 'ptr', 'oan', 'cgr', 'mmu', 'rno', 'bta', 'oar', 'ssc', 'dre', 'ola', 'aae', 'ame', 'api', 'bmo', 'dme', 'tca', 'cbr', 'cel', 'ppt', 'aly', 'ath', 'mes', 'gma', 'mtr', 'lus', 'mdm', 'ppe', 'ptc', 'stu', 'vvi', 'bdi', 'osa', 'sbi', 'zma')
FS <- c("FS1","FS2","FS3","FS4","FS5","FS6","FS7","SELECT","hib37","hibsel7","hib17","sub1","Emv8","Ewv8")
FS24 <- c("Emv24","Ewv24")


for (algoi in 1:length(alg)) {
	for (fsi in 1:length(FS)) {
		fin <- paste( "anova/Accuracy_",FS[fsi],"_",alg[algoi],".csv", sep="" )
		readfin <- read.csv( fin, header = FALSE )
		labels1 <- specie
		tr <- gl(45,450,labels=labels1)#
		te <- gl(45,10,labels=labels1)#
		blk <- factor(rep(1:10,45))
		dm <- data.frame(tr,te,blk)
		y<-data.frame(readfin$V4)
		dfm <- data.frame(dm,y)
		for (i in 1:length(labels1)){
		   nsk1 <- with(dfm,SK.nest(x=dm,y=y,model='y ~ blk + te*tr',which='tr:te',fl1=i))
		   out <- capture.output(as.matrix((summary(nsk1))))
		   f1 <- paste("Clusters/",alg[algoi],"_",FS[fsi],"_compare_test_spe_predicted_by_",labels1[i],sep='')
		   write(out,file=f1,ncolumns = 2,sep="\n",append=F)}
		for (i in 1:length(labels1)){
		   nsk2 <- with(dfm,SK.nest(x=dm,y=y,model='y ~ blk + tr*te',which='te:tr',fl1=i))
		   out <- capture.output(as.matrix((summary(nsk2))))
		   f1 <- paste("Clusters/",alg[algoi],"_",FS[fsi],"_compare_model_spe_in_predicting_",labels1[i],sep='')
		   write(out,file=f1,ncolumns = 2,sep="\n",append=F) }
			}
		}

for (fsi in 1:length(FS24)) {
	fin <- paste( "anova/Accuracy_",FS24[fsi],".csv", sep="" )
	readfin <- read.csv( fin, header = FALSE )
	labels1 <- specie
	tr <- gl(45,450,labels=labels1)#
	te <- gl(45,10,labels=labels1)#
	blk <- factor(rep(1:10,45))
	dm <- data.frame(tr,te,blk)
	y<-data.frame(readfin$V4)
	dfm <- data.frame(dm,y)
	for (i in 1:length(labels1)){
	   nsk1 <- with(dfm,SK.nest(x=dm,y=y,model='y ~ blk + te*tr',which='tr:te',fl1=i))
	   out <- capture.output(as.matrix((summary(nsk1))))
	   f1 <- paste("Clusters/",FS24[fsi],"_compare_test_spe_predicted_by_",labels1[i],sep='')
	   write(out,file=f1,ncolumns = 2,sep="\n",append=F)}
	for (i in 1:length(labels1)){
	   nsk2 <- with(dfm,SK.nest(x=dm,y=y,model='y ~ blk + tr*te',which='te:tr',fl1=i))
	   out <- capture.output(as.matrix((summary(nsk2))))
	   f1 <- paste("Clusters/",FS24[fsi],"_compare_model_spe_in_predicting_",labels1[i],sep='')
	   write(out,file=f1,ncolumns = 2,sep="\n",append=F) }
		}
