#By Ivani de Oliveria Negrao Lopes
#Figure 2
library('fields')
setwd("..")
root <- getwd()

fs = c("FS1","FS2","FS3","FS4","FS5","FS6","FS7","SELECT")
alg <- c("SVM","RF","J48")

cbbPalette <- c("#66A61E","#E31A1C") # "#E31A1C","#1F78B4","#66A61E"

png(paste("anova/Figure2.png", sep=''),800,825) 

par(mar=c(3.5,3.5,2.5,1), mfrow=c(2,2))

###################
#(1,1)
fin <- read.csv(paste("anova/Cluster_tr_given_te_",alg[1],"_",fs[8],".csv", sep=''),header = FALSE)
label <-  as.vector(fin[1])
x <- as.matrix(fin[2:length(fin)])
#~ xt <- t(x)
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2),main="SVMs_SELECT")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2)
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 1 )

###################
#(1,2)
fin <- read.csv(paste("anova/Cluster_tr_given_te_",alg[2],"_",fs[8],".csv", sep=''),header = FALSE)
x <- as.matrix(fin[2:length(fin)])
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2), main="RF_SELECT")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2 )
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 2 )

###################
#(2,1)
fin <- read.csv(paste("anova/Cluster_tr_given_te_",alg[1],"_",fs[6],".csv", sep=''),header = FALSE)
label <-  as.vector(fin[1])
x <- as.matrix(fin[2:length(fin)])
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2),main="SVMs_FS5")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2 )
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 2 )

###################
#(2,2)
fin <- read.csv(paste("anova/Cluster_tr_given_te_",alg[2],"_",fs[6],".csv", sep=''),header = FALSE)
x <- as.matrix(fin[2:length(fin)])
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2),main="RF_FS5")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2)
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 1 )

dev.off()
