#By Ivani de Oliveria Negrao Lopes
#Tables used in this script are generated by the script: Tables_Clustering_MaximalAcc_or_Other.py
#Figure 3

library('fields')
setwd("..")

fs = c("FS1","FS2","FS3","FS4","FS5","FS6","FS7","SELECT")
alg <- c("SVM","RF","J48")

cbbPalette <- c("#1b9e77","#d95f02") # 

png(paste("anova/Figure3.png", sep=''),800,825) 

par(mar=c(3.5,3.5,2.5,1), mfrow=c(2,2))

###################
#(1,1)
fin <- read.csv(paste("Clusters/Cluster_te_given_tr_",alg[1],"_",fs[8],".csv", sep=''),header = FALSE)
label <-  as.vector(fin[1])
x <- as.matrix(fin[2:length(fin)])
#~ xt <- t(x)
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2),main="SVMs_SELECT")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2)
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 1 )

###################
#(1,2)
fin <- read.csv(paste("Clusters/Cluster_te_given_tr_",alg[2],"_",fs[8],".csv", sep=''),header = FALSE)
x <- as.matrix(fin[2:length(fin)])
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2), main="RF_SELECT")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2 )
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 2 )

###################
#(2,1)
fin <- read.csv(paste("Clusters/Cluster_te_given_tr_",alg[1],"_",fs[6],".csv", sep=''),header = FALSE)
label <-  as.vector(fin[1])
x <- as.matrix(fin[2:length(fin)])
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2),main="SVMs_FS5")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2 )
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 2 )

###################
#(2,2)
fin <- read.csv(paste("Clusters/Cluster_te_given_tr_",alg[2],"_",fs[6],".csv", sep=''),header = FALSE)
x <- as.matrix(fin[2:length(fin)])
xt <- x
image(xt,axes = FALSE, lwd=1, col = cbbPalette,breaks = c(0,1,2),main="RF_FS5")
axis( 1, at=seq(0,1,length.out=45), labels= t(label), las= 2)
axis( 2, at=seq(0,1,length.out=45), labels= t(label), las= 1 )

dev.off()
