setwd("..")

#~ root <- getwd()
#~ fs = c("FS1","FS2","FS3","FS4","FS5","FS6","FS7","SELECT","hib37","hibsel7","hib17","sub1","Emv8","Ewv8")
fs=c("FS1","FS6","SELECT")

legendt <- c("e1", "e2", "e3", "e4", "e5", "e6", "e7" )

specie <- c('bfl', 'cin', 'cbr', 'cel', 'aae', 'ame', 'api', 'bmo', 'dme', 'tca', 'aca', 'xtr', 'gga', 'cfa', 'eca', 'mdo', 'mml', 'ggo', 'hsa', 'ptr', 'oan', 'cgr', 'mmu', 'rno', 'bta', 'oar', 'ssc', 'dre', 'ola', 'ppt', 'aly', 'ath', 'mes', 'gma', 'mtr', 'lus', 'mdm', 'ppe', 'ptc', 'stu', 'vvi', 'bdi', 'osa', 'sbi', 'zma')

cbbPalette <- c("#000000", "#009E73", "#e79f00", "#9ad0f3", "#0072B2", "#D55E00", "#CC79A7")

png("errors/Figure4.png",1000,unit='px') #height=475,width=900
par(mar=c(0,3,2,2), mfrow=c(1,3))
#~ plot.new() mar=c(Inferior,esquerda,superior, direita)
auxmain = c("(a) ","(b) ","(c) ")
for (fsi in 1:length(fs)) {
	fname <- paste("errors/Errors_algoritmos_",fs[fsi],".csv", sep="" )
	fin <- data.frame(read.csv(fname, header = FALSE))
	#Plot errors per specie
	h <- as.matrix(fin)
	#legend
	leg <-list(y = ncol(h) + 3, x=max(colSums(h))+14, bty = "n", col=cbbPalette ) #
#~ 	par(mar=c(3.5,3.5,3,1.5))
	#subfigure 
	mainfs <- paste(auxmain[fsi],fs[fsi],sep='')
	barplot(height=h, beside=FALSE, names.arg=specie,legend.text=legendt,main=mainfs,args.legend=leg, col=cbbPalette, cex.names=0.25,horiz=TRUE, xlim=c(0,110), axes=F, axisnames=T, border=NA)

	axis( 2, at=seq(0.5,53.5,length.out=45), labels= specie, las= 1)
#~ 	axis( 1, at=c(0,10,20,30,40,50,60,70,80,90,100), labels= c('0','10','20','30','40','50','60','70','80','90','100'), las= 1)
}
dev.off()
