library(VennDiagram)
library(grid)
library(gridBase)
library(lattice)

setwd("..")

#~ root <- getwd()
#Sets of misclassified instances by SVMs,DTs (J48) and RFs obtained with FS1
f11 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS1_SVM.csv"), header = FALSE ),"SVMs")
f12 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS1_RF.csv"), header = FALSE ),"RFs")
f13 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS1_J48.csv"), header = FALSE ),"J48")

#Sets of misclassified instances by SVMs,DTs (J48) and RFs obtained with FS6
f21 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS6_SVM.csv"), header = FALSE ),"SVMs")
f22 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS6_RF.csv"), header = FALSE ),"RFs")
f23 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS6_J48.csv"), header = FALSE ),"J48")

#Sets of misclassified instances by SVMs,DTs (J48) and RFs obtained with FS7
f31 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS7_SVM.csv"), header = FALSE ),"SVMs")
f32 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS7_RF.csv"), header = FALSE ),"RFs")
f33 <-setNames(as.list(read.csv("errors/Venn/VennSet_FS7_J48.csv"), header = FALSE ),"J48")

#Sets of misclassified instances by SVMs,DTs (J48) and RFs obtained with SELECT
f41 <-setNames(as.list(read.csv("errors/Venn/VennSet_SELECT_SVM.csv"), header = FALSE ),"SVMs")
f42 <-setNames(as.list(read.csv("errors/Venn/VennSet_SELECT_RF.csv"), header = FALSE ),"RFs")
f43 <-setNames(as.list(read.csv("errors/Venn/VennSet_SELECT_J48.csv"), header = FALSE ),"J48")

#Build and assemble the four Venn diagrams
fig4 <- "errors/figures/Figure6.png"
png(fig4,1200,1200,units = "px") 

gridlayout <- grid.layout(nrow=2, ncol=2)

gt.1 <- viewport(layout.pos.col=1, layout.pos.row=1) 
gt.2 <- viewport(layout.pos.col=2, layout.pos.row=1) 
gt.3 <- viewport(layout.pos.col=1, layout.pos.row=2) 
gt.4 <- viewport(layout.pos.col=2, layout.pos.row=2)

pushViewport(viewport(layout=gridlayout))

lab=c("(a) FS1)","(b) FS6)","(c) FS7)","(d) SELECT")

for (i in 1:4){
    gt.i <- paste("gt.", i, sep="")
    pushViewport(get(gt.i))
    fi1<-get(paste("f",i,"1",sep=''))
    fi2<-get(paste("f",i,"2",sep=''))
    fi3<-get(paste("f",i,"3",sep=''))
	fig <- venn.diagram(c(fi1,fi2,fi3),main=lab[i],main.pos=c(0.5,1.0),cex=2,cat.cex = 2,main.cex=2,margin=0.05,fill=c("red","green3","blue"),filename=NULL)#
	grid.draw(gTree(children=fig, vp=viewport(width=0.9,height=0.9)))
	popViewport()
	}

dev.off()
