#!/opt/bin/python2.7
#By Ivani de Oliveria Negrao Lopes
#Tables used in this script are generated by the script: Multispecies.py

from collections import defaultdict
from os import getcwd, path, chdir, mkdir
import re, csv
global species, Mod20, Mod24, Mod44

A = ["SVM","RF","J48"]

species= ["bfl","cin","cbr","cel","aae","ame","api","bmo","dme","tca","aca","xtr","gga","cfa","eca","mdo","mml","ggo","hsa","ptr","oan","cgr","mmu","rno","bta","oar","ssc","dre","ola","ppt","aly","ath","mes","gma","mtr","lus","mdm","ppe","ptc","stu","vvi","bdi","osa","sbi","zma"]

FS8 = ["FS1","FS2","FS3","FS4","FS5","FS6","FS7","SELECT"]
newFS = ["hib37","hibsel7","hib17","sub1"]
Ens8=["Emv8","Ewv8"]
Comm24 = ["Emv24","Ewv24"]


Mod24 = [x+'_'+y for x in A for y in FS8]
ModnewFS = [x+'_'+y for x in A for y in newFS]
ModEns8=[x+'_'+y for x in Ens8 for y in A]
Mod20 = ModnewFS + ModEns8 + Comm24
Mod44 = Mod24 + Mod20


#Print the file to run the anovas of classifiers for each species
def print_anova_files(modlist):
	nmod=str(len(modlist))
	for spe in species:
		w=equals[spe]
		fou = 'Models/'+'Accuracy_'+ nmod + '_' + spe + '.csv'
		fw = csv.writer(file(fou,'w'), dialect='excel')
		fw.writerows(w)


#From the general accuracies files, extract only those where tr=te and add to equals
def AddToEquals(m):
	fin = 'anova/Accuracy_' + m + '.csv'
	with open(fin) as f:
		rf = csv.reader(f, delimiter=",")
		for l in rf:
			tr=l[0].split('_')[-1]
			te=l[1].split('_')[-1]
			if tr!=te:
				pass
			else:
				equals[tr].append([m,l[2],l[3]])
	
	
#Summarize procedures to obtain the anova and Skott-Knott clustering
def Anova_equals():
	global equals
	equals=defaultdict(list)
	for m in Mod24:				
		AddToEquals(m)
	print_anova_files(Mod24)		
	for m in Mod20:				
		AddToEquals(m)
	print_anova_files(Mod44)	
		

if __name__=="__main__":
	chdir("..")
	moddir=path.join(getcwd(),"Models")
	if path.exists(moddir):
		pass
	else:
		mkdir(moddir,0755)
	Anova_equals()
