#!/opt/bin/python2.7
#By Ivani de Oliveria Negrao Lopes
#Results generated here depends on the results of Files_Anova_Models.py
#This script generates the frequencies tables used to produce figures 1 and 6
from collections import defaultdict
from os import getcwd, path, chdir, mkdir
import re, csv
global species

A = ["SVM","RF","J48"]

species= ["bfl","cin","cbr","cel","aae","ame","api","bmo","dme","tca","aca","xtr","gga","cfa","eca","mdo","mml","ggo","hsa","ptr","oan","cgr","mmu","rno","bta","oar","ssc","dre","ola","ppt","aly","ath","mes","gma","mtr","lus","mdm","ppe","ptc","stu","vvi","bdi","osa","sbi","zma"]

FS8 = ["FS1","FS2","FS3","FS4","FS5","FS6","FS7","SELECT"]
newFS = ["hib37","hibsel7","hib17","sub1"]
Ens8=["Emv8","Ewv8"]
Comm24 = ["Emv24","Ewv24"]


Mod24 = [x+'_'+y for x in A for y in FS8]
ModnewFS = [x+'_'+y for x in A for y in newFS]
ModEns8=[x+'_'+y for x in Ens8 for y in A]
Mod20 = ModnewFS + ModEns8 + Comm24
Mod44 = Mod24 + Mod20

#Edit original representation to C1..C7
def check_all_clusters(c):
	alfa=['a', 'b', 'c', 'd', 'e', 'f', 'g']
	i=0
	for j in alfa:
		i+=1
		if c==j:
			cl = "C" + str(i)
	return cl


#Process rows from skott-knott files	
def read_cluster(l):
	ls=l.split()
	mod = ls[0].split("/")[0] #model
	cl = check_all_clusters(ls[-1]) #cluster
	return mod,cl

	
#Create the file to produce Figure 3 for one algorithm and fs
def AddToFreqac(fin,nmod):
	f=open(fin).readlines()
	for l in f[1:nmod+1]:
		lin=read_cluster(l) #return the cluster and the test species
		letters.append(lin[1])
		Freqac[nmod,lin[0],lin[1]]+=1


#Tor sort cluster information according to the species order in the species list
def create_freqlist(nmod,Mlist):
	llett=list(set(letters))
	llett.sort()
	allrows=[]
	for m in Mlist:
		onerow=[m]
		for cl in llett:
			if (nmod,m,cl) in Freqac.keys():
				onerow.append(Freqac[nmod,m,cl])
			else:
				onerow.append(0)
		allrows.append(onerow)
	return allrows
		

#To print files
def print_freq_files(nmod,Mlist,fou):
	allrows = create_freqlist(nmod,Mlist)
	fw = csv.writer(file(fou,'w'), dialect='excel')
	fw.writerows(allrows)
		
				
#Compute the frequencies by which a model classified the test sets with accuracies in each 
#cluster, where tr = te. Figure 1 shows 24 cases and Figure 6 shows all models
def freqall():
	global Freqac, letters
	nmod,Mlist=[24,44],[Mod24,Mod44]
	for i in range(len(nmod)):
		letters=[]
		Freqac=defaultdict(int)
		for sp in species:
			fin="Models/Compare_" + str(nmod[i]) + "_Models_for_" + sp + ".txt"
			if path.exists(fin):
				AddToFreqac(fin,nmod[i])
			else:
				print "File % doesn't exists" %fin
		fou = 'Models/Freq_' + str(nmod[i]) + '.csv'
		print_freq_files(nmod[i],Mlist[i],fou)	


if __name__=="__main__":
	chdir("..")
	freqall()
