#!/opt/bin/python2.7
#By Ivani de Oliveria Negrao Lopes
#Tables used in this script are in the folder PredictedClasses
#Results generated here are the input for all the other scripts

from os import getcwd, path, mkdir,chdir
import Pool_of_Functions_Base as pof

A=["SVM","RF","J48"]
F=["FS1","FS2","FS3","FS4","FS5","FS6","FS7","hib17","hib37","hibsel7","SELECT","sub1"]
sp=["bfl","cin","cbr","cel","aae","ame","api","bmo","dme","tca","aca","xtr","gga","cfa","eca","mdo","mml","ggo","hsa","ptr","oan","cgr","mmu","rno","bta","oar","ssc","dre","ola","ppt","aly","ath","mes","gma","mtr","lus","mdm","ppe","ptc","stu","vvi","bdi","osa","sbi","zma"]

n=30 #number of first postives
printall=0 #Keep zero to prevent the creation of a file for each test set classified by the ensembles. Otherwise, change it to 1 

#~ myF=[F[x] for x in [0]] #Feature sets to be evaluated in single classifiers
#~ myAlgoList=[A[x] for x in [0]] #
#~ mySpeciesList=[sp[x] for x in [0]]

myF=F 
myAlgoList=A 
mySpeciesList=sp

#Algorithms to be considered in the ensembles
AlgCombination=[[A[0]],[A[1]],[A[2]],A] 
#suffix to build the ensembles names. This names need to be in accordance with the definition of the list AlgCombination
CommitteeSuffix=["8_SVM","8_RF","8_J48","24"]
#Feature sets for the ensemble
Committee=[F[x] for x in [2,3,4,7,8,9,10,11]] 
weightlist=['mv','wv']

if __name__=="__main__":
	chdir('..')
	anadir=path.join(getcwd(), "anova")
	if path.exists(anadir):
		pass
	else:
		mkdir(anadir,0755)
	#compute the accuracy of single classifiers, as defined in the list of algorithms, feature sets and species
	pof.accuracy_of_single_classifiers(myAlgoList,myF,mySpeciesList,n)
	#Compute the accuracies of one or more ensembles, as defined in the list of Algorithm combinations mySpeciesList.
	# If print all is reset to a value different of zero, this function also prints all a file with the predicted classes of the ensembles. Reset printall may generate thousands of files.
	#For example: if the eight approaches [Algorithm Combinations vs Weights]=[ 4 x 2] and the number of species tried is 45, reseting print all will create: 4*2*45*45*10=162k additional files
	pof.Accuracy_ensemble(AlgCombination,Committee,weightlist,CommitteeSuffix,mySpeciesList,printall,n)
	#To obtain the errors
	errordir=path.join(getcwd(), "errors")
	vendir=path.join(errordir, "Venn")
	if path.exists(errordir):
		pass
	else:
		mkdir(errordir,0755)
		mkdir(vendir,0755)
	pof.execute_error_functions(A,myF,mySpeciesList,n)	
		
