#!/opt/bin/python2.7
#script to normalize the importance of each feature for each species and compute. 
#The output is the mean of 10 repetitions
from collections import defaultdict
import csv
from os import chdir, getcwd
	
specie=['bfl','cin','cbr','cel','aae','ame','api','bmo','dme','tca','aca','xtr','gga','cfa','eca','mdo','mml','ggo','hsa','ptr','oan','cgr','mmu','rno','bta','oar','ssc','dre','ola','ppt','aly','ath','mes','gma','mtr','lus','mdm','ppe','ptc','stu','vvi','bdi','osa','sbi','zma']

hparse = defaultdict()
RFIextrem = defaultdict(list)
RFImean = []

for sp in specie:
	for rep in range(1,11,1):
		f1 = open("../importance/imp_files/importance_" + sp + "_"  + str(rep)).readlines()
		featid=1
		for line in f1:
			linespl=float(line.split()[0])
			RFIextrem[sp,rep].append(linespl)
			hparse[sp,rep,featid]=linespl
			featid +=1

for i in range(1,86,1):
	auxmean,auxsd=[],[]
	for sp in specie:
		somax,somax2=0,0
		for rep in range(1,11,1):
			maxrfi=max(RFIextrem[sp,rep])
			minrfi=min(RFIextrem[sp,rep])
			x = 100.0*(hparse[sp,rep,i]-minrfi)/(maxrfi-minrfi)
			somax +=x
		xbar = somax/10.0
		auxmean.append(xbar)
	RFImean.append(auxmean)
	
	
fmean=csv.writer(file( "../importance/RFImean.csv", 'w' ), dialect='excel')		
fmean.writerows(RFImean)		
	

