#!/usr/bin/python
#By Ivani de Oliveira Negrao Lopes
#For this paper, infile was "Accuracy_SELECT_SVM.csv"
import sys, csv

def exit_with_help():
	print """\
Usage: %s fullset

Subset full set to take only the 26 species for which the phylogeny was known .""" % sys.argv[0]
	exit(1)

if len(sys.argv) < 2:
   exit_with_help()

infile = sys.argv[1]
outfile = infile.split(".")[0]+"_26.csv"

spe=["ola","dre","rno","mmu","hsa","ptr","ggo","mml","eca","bta","ssc","cfa","mdo","oan","aca","gga","xtr","cin","ame","dme","aae","bmo","tca","api","cbr","cel"]


dic26={}
with open(infile, 'rb') as fi:
    readeri = csv.reader(fi, delimiter=',')
    for i in readeri:
		idtr= i[0]
		idte= i[1]
		if (idtr in spe and idte in spe): 
			dic26[(idtr,idte,i[2])]=[idtr,idte,i[2],i[3]]


w=[]
for i in spe:
	for j in spe:
		for rep in range(1,11):
			key=(i,j,str(rep))
			if key in dic26.keys():
				w.append(dic26[key])
			
fw= csv.writer(file(outfile,'w'),delimiter=',',dialect='excel')
fw.writerows(w)

