#!/opt/bin/python2.7
#By Ivani de Oliveria Negrao Lopes
from collections import defaultdict
from sys import argv, exit
from random import choice
from math import sqrt
from os import getcwd, path, mkdir
import re, csv

global Venn, errors,summerror
errors=defaultdict()
Venn=defaultdict(list)
summerror=defaultdict(int)

#Function to classify an instance based on the score - used in the ensemble function
def reclassify(score):
	if score > 0:
		predclass = 1
	elif score < 0:
		predclass = -1
	else:
		predclass = choice([1,-1])
	return predclass


#Function to compute accuracy, given the numbers of: 
#tp=true positives; fn=false negatives; tn=true negatives; fp=false positives
def compute_accuracy(tp,fn,tn,fp):
	den = tp+fn+tn+fp
	num = (tp + tn)
	acc = round(100.0*num/den,1)
	return acc	

	
#Function to find the confusion matrix from a list of predicted classes, 
#where the first n were true postives.
def confusion_matrix(lista,n):
	nline,tp,fn,tn,fp=0,0,0,0,0
	for classe in lista:
		if ( classe == 1 and nline < n):
			tp+=1
		elif (classe == -1 and nline < n):
			fn+=1
		elif (classe == 1 and nline >= n):
			fp+=1
		elif (classe == -1 and nline >= n):
			tn+=1
		nline+=1
	acc = compute_accuracy(tp,fn,tn,fp)
	return acc


#Function to split a string using multiple delimiters
def split_string_multidel(s):
	spl = filter( None,re.split("[: % = \" \[\] \\n]", s ) )
	return spl


#Funtion to open the file containing the training report from SVMs and return the cross-validation accuracy
def CrossVal_acc_SVM(fcrossval):
	line = open(fcrossval).readlines()[0]
	CVacc = split_string_multidel(line)[1]
	return float(CVacc)


#Funtion to open the file containing the training report from RFs and return the cross-validation accuracy
def CrossVal_acc_RF(fcrossval):
	line = open(fcrossval).readlines()[7]
	CVacc = 100-float(split_string_multidel(line)[5])	
	return CVacc


#Funtion to open the file containing the training report from DTs of the J48 algorithm and retur the cross-validation accuracy
def CrossVal_acc_J48(fcrossval):
	line = open(fcrossval).readlines()[4]
	CVacc = split_string_multidel(line)[4]
	return float(CVacc)


#Function to colect classes predicted for the individuals of a test set
#Weight=0 if majority vote and 1 if weighted vote; w=accuracy in cross-validation
#pos=column of the predicted class; startpos=first valid row
def namefiles(al,FS,spetr,spete,rep,weight):
	global fpred,fcrossval, pos, startpos, w
	if al == 'SVM':
		fpred = "PredictedClasses/" + al + "/"  + FS + "/" + "test_"+ spete + "_" + str(rep) + "." + spetr + ".predict"
		pos,startpos=0,0
		if weight!=0:
			fcrossval = "CrossVall/"+al +"/"+ FS + "/Accuracy_cv_" + spetr + "_" + str(rep)
			w=CrossVal_acc_SVM(fcrossval) 
		else:
			w=1	
	else:
		fpred = "PredictedClasses/" + al + "/"  + FS + "/out_"+ spete + "_" + str(rep) + "." + spetr
		pos,startpos=1,1 
		if weight!=0:
			fcrossval = "CrossVall/"+al + "/" + FS + "/cv_" + spetr + "_" + str(rep)
			if al=='RF':
				w=CrossVal_acc_RF(fcrossval)
			elif al=='J48':
				CrossVal_acc_J48(fcrossval)
		else:
			w=1
								

#Function to collect votes and weights for a specific ensemble
def Collect_Votes_Weights(algorithmlist,FsCommittees,spetr,spete,rep,weight):
	global vote, lenfin
	vote=defaultdict()
	for al in algorithmlist:
		for FS in FsCommittees:
			namefiles(al,FS,spetr,spete,rep,weight)
			fin=open(fpred).readlines()[startpos:]
			lenfin=len(fin)
			for l in range(len(fin)):
				claux1 = split_string_multidel(fin[l])
				classe = int(claux1[pos])
				vote[(al,FS,spetr,spete,rep,l,"class")] = classe
				vote[(al,FS,spetr,spete,rep,l,"w")] = w
								


#Function to classify a test set by one commitee/ensemble 
def ensemble(algorithmlist,FsCommittees,spetr,spete,rep,ename,weight,n):
	Collect_Votes_Weights(algorithmlist,FsCommittees,spetr,spete,rep,weight)
	predlist=[]
	if ename==0:
		for l in range(lenfin):
			v,sumw = 0,0
			for al in algorithmlist:
				for FS in FsCommittees:
					v +=vote[(al,FS,spetr,spete,rep,l,"class")]*vote[(al,FS,spetr,spete,rep,l,"w")]
					sumw +=vote[(al,FS,spetr,spete,rep,l,"w")]
			score=1.0*v/sumw
			predclass = reclassify(score)
			predlist.append(predclass)
		acc = confusion_matrix(predlist,n)
	else:
		fw = csv.writer(file(ename), dialect='excel')
		for l in range(lenfin):
			v,sumw = 0,0
			for al in algorithmlist:
				for FS in FsCommittees:
					cl =  vote[(al,FS,spetr,spete,rep,l,"class")]
					clw = vote[(al,FS,spetr,spete,rep,l,"w")]
					v +=cl*clw
					sumw +=clw
			score=1.0*v/sumw
			predclass = reclassify(score)
			predlist.append(predclass)
		acc = confusion_matrix(predlist,n)
		fw.writerows(predlist)
	return acc



#Function to compute the accuracies test of all ensembles in all test sets 
def Accuracy_ensemble(AlgCombination,FsCommittees,WeightList,CommitteeSuffix,mySpeciesList,printall,n):
	for i in range(len(AlgCombination)):
		alg=AlgCombination[i]
		for weight in [0,1]:
			AccAll=[] #to append all rows in the accuracy file
			ensemblename='E'+ WeightList[weight] + CommitteeSuffix[i] #define the ensemble names
			for spetr in mySpeciesList:
				trname='tr_'+spetr #define of the training species
				for spete in mySpeciesList:
					tename='te_'+spete #define of the test species
					for rep in range(1,11):
						AccRow=[trname,tename,rep] # One row in the accuracy file
						if printall==0:
							fname=0 
						else:
							outdir=path.join("PredictedClasses",ensemblename) #
							fname = path.join(outdir,"out_"+ spete + "_" + str(rep) + "." + spetr)
							if path.exists(path.join(getcwd(), outdir)):
								pass
							else:
								mkdir(outdir,0755)
						AccVal = ensemble(alg,FsCommittees,spetr,spete,rep,fname,weight,n)
						AccRow.append(AccVal)
						AccAll.append(AccRow)
			anadir=path.join(getcwd(), "anova")
			f = path.join(anadir,"Accuracy_" + ensemblename + ".csv")
			fw = csv.writer(file(f,'w'), dialect="excel")
			fw.writerows(AccAll)

##################################################################

#Function to compute the accuracy of one single classifier from all test sets
def Accuracy_single(alg,fs,spetr,spete,rep,weight,n):
	ClassList=[]
	namefiles(alg,fs,spetr,spete,rep,weight)
	fin=open(fpred).readlines()[startpos:]
	lenfin=len(fin)
	if alg=="SVM":
		col=0
	else:
		col=1
	for l in fin:
		classeaux = split_string_multidel(l)
		classe = int(classeaux[col])
		ClassList.append(classe)
	acc = confusion_matrix(ClassList,n)
	return acc



#Function to compute the accuracies test of single classifiers in all test sets
def accuracy_of_single_classifiers(myAlgoList,myF,mySpeciesList,n):
	for alg in myAlgoList:
		for fs in myF:
			AccAll = [] #to append all rows in the accuracy file
			for spetr in mySpeciesList:
				trname='tr_'+spetr #define of the training species
				for spete in mySpeciesList:
					tename='te_'+spete #define of the test species
					for rep in range(1,11):
						AccRow=[trname,tename,rep,Accuracy_single(alg,fs,spetr,spete,rep,0,n)] # One row in the accuracy file
						AccAll.append(AccRow)
			anadir=path.join(getcwd(), "anova")
			f = path.join(anadir,"Accuracy_" + alg + "_" + fs + ".csv")
			fw = csv.writer(file(f,'w'), dialect='excel')
			fw.writerows(AccAll)




#################################################################################
#Takes the classes predicted by the three algorithms and the true class
#and return one of the seven errors. Data are used to produce Figures 5 and 7
def what_error(clA1,clA2,clA3,tc):
	if (clA1 != tc and (clA2 == tc and clA3 == tc)):
		e="e1"
	elif (clA2 != tc and (clA1 == tc and clA3 == tc)):
		e="e2"
	elif (clA3 != tc and (clA1 == tc and clA2 == tc)):
		e="e3"
	elif ((clA1 != tc and clA2 != tc) and clA3 == tc):
		e="e4"
	elif ((clA1 != tc and clA3 != tc)  and clA2 == tc):
		e="e5"
	elif ((clA2 != tc and clA3 != tc)  and clA1) == tc:
		e="e6"
	elif ((clA1 != tc and clA2 != tc and clA3 != tc)):
		e="e7"
	else:
		e=0	
	return e



#Function to identify misclassified instances by one model
def identify_misclassified(alg,fs,spetr,spete,rep,weight,n):
	namefiles(alg,fs,spetr,spete,rep,weight)
	fin=open(fpred).readlines()[startpos:]
	lenfin=len(fin)
	if alg=="SVM":
		col=0
	else:
		col=1
	i=0
	for l in fin:
		classeaux = split_string_multidel(l)
		classe = int(classeaux[col])
		spe=spetr
		obs = spe + "_" + str(rep) + "_" + str(i+1)
		if i<n:
			tc=1
			if classe==-1:
				Venn[alg,fs].append([obs])
			else:
				pass
		elif i>=n:
			tc=-1
			if classe==1:
				
				Venn[alg,fs].append([obs])	
			else:
				pass			
		else:
			pass
		errors[alg,fs,spe,rep,i,"PCl"]=classe
		errors[spe,rep,i,"TCl"]=tc			
		i+=1

#Function to identify misclassified instances by models defined by the 
#combinations in the lists myAlgoList, myF and mySpeciesList
def identify_all_misclassified(A,myF,mySpeciesList,n):
	for alg in A:
		for fs in myF:
			for spetr in mySpeciesList:
				for spete in mySpeciesList:
					if spetr==spete:
						for rep in range(1,11):
							identify_misclassified(alg,fs,spetr,spete,rep,0,n)
					else:
						pass



#Print tables to produce Figure 5
def print_table_summerrors(myF,mySpeciesList):
	for fs in myF:
		w=[]
		for spe in mySpeciesList:
			aux=[spe]
			#Totals the seven errors to compute the relative errors
			TotE=0
			for e in ["e1","e2","e3","e4","e5","e6","e7"]:
				TotE +=summerror[fs,spe,e]
			for e in ["e1","e2","e3","e4","e5","e6","e7"]:
				if (fs,spe,e) in summerror.keys():
					er = 1.0*summerror[fs,spe,e]/TotE
					aux.append(er)
				else:
					aux.append(0)
			w.append(aux)
		f = path.join("errors","Errors_algoritmos_" + fs + ".csv")
		fw = csv.writer(file(f,'w'), dialect='excel')
		fw.writerows(w)		



#Counts the number of misclassified instances according to e1...e7
def count_errors(myF,mySpeciesList):
	for fs in myF:
		for spe in mySpeciesList:
			for rep in range(1,11):
				for l in range(60):
					ea1=errors["SVM",fs,spe,rep,l,"PCl"]
					ea2=errors["RF",fs,spe,rep,l,"PCl"]
					ea3=errors["J48",fs,spe,rep,l,"PCl"]
					TCl = errors[spe,rep,l,"TCl"]
					e = what_error(ea1,ea2,ea3,TCl)
					if e==0:
						pass
					else:
						summerror[fs,spe,e] += 1
	print_table_summerrors(myF,mySpeciesList)						
				
				
				
#Print tables identifying misclassified instances - to produce Figure 7
def data_for_venn_diagram(A,myF):
	for fs in myF:
		for alg in A:
			w = Venn[alg,fs]
			f = path.join("errors","Venn","VennSet_" + fs +  "_" + alg + ".csv")
			fw = csv.writer(file(f,'w'), dialect='excel')
			fw.writerows(w)				
						
							
							
#To call error functions				
def execute_error_functions(A,myF,mySpeciesList,n):
	identify_all_misclassified(A,myF,mySpeciesList,n)#Creates the errors and Venn dictionaries				
	count_errors(myF,mySpeciesList)	#Compute and print tables for Figure 5
	data_for_venn_diagram(A,myF) #Print tables 
							
							
							
						
