#!/opt/bin/python2.7
#By Ivani de Oliveria Negrao Lopes
#Tables used in this script are generated by the script: Anova_Cross_Species.R

from collections import defaultdict
from os import getcwd, path, mkdir
import csv
global FS, FS24, species, A

chdir("..")
species= ["bfl","cin","cbr","cel","aae","ame","api","bmo","dme","tca","aca","xtr","gga","cfa","eca","mdo","mml","ggo","hsa","ptr","oan","cgr","mmu","rno","bta","oar","ssc","dre","ola","ppt","aly","ath","mes","gma","mtr","lus","mdm","ppe","ptc","stu","vvi","bdi","osa","sbi","zma"]
FS = ["FS1","FS2","FS3","FS4","FS5","FS6","FS7","SELECT","hib37","hibsel7","hib17","sub1","Emv8","Ewv8"]
FS24 <- ["Emv24","Ewv24"]
A = ["SVM","RF","J48"]

#Just edit original representation to C1..
def check_all_clusters(c):
	alfa=['a', 'b', 'c', 'd', 'e', 'f', 'g']
	i=0
	for j in alfa:
		i+=1
		if c==j:
			cl = "C" + str(i)
	return cl


#Decide if cluster belongs to maximal acc cluster or other cluster
def check_cluster(c):
	if c=="a":
		cl="C" + str(1)
	else:
		cl="C" +str(2)
	return cl


#Process rows from skott-knott files	
def read_cluster(l,trpos,tepos):
	ls=l.split()
	tr = ls[0].split("/")[trpos] #test species
	te = ls[0].split("/")[tepos] #training species
	cl12 = check_cluster(ls[-1])
	return tr,te,cl12

	
#Create the file to produce Figure 3 for one algorithm and fs
def add_to_w(fin,trpos,tepos):
	with open(fin) as f:
		for l in f[2:47]:
			linfo=read_cluster(l,trpos,tepos) #return the cluster and the test species
			w[linfo[0],linfo[1]]=linfo[1]


#Tor sort cluster information according to the species order in the species list
def create_allrows(w):
	allrows=[]
	for tr in species:
		onerow=[tr]
		for te in species:
			onerow.append(te)
			onerow.append(w[tr,te])
		allrows.append(onerow)
	return allrows
	

def print_files(w,fout):
	allrows = create_allrows(w)
	fw = csv.writer(file(fout,'w'), dialect='excel')
	fw.writerows(allrows)


def summarizeall(clusdir):
	global w
	for algo in A:				
		for fs in FS:
			#compare tr given te - Figure 2 shows the cases (SVM,RF)x(FS6,SELECT)
			w={}	
			for sp in species:	
				trpos,tepos = 1,0
				fin = path.join(clusdir,algo + "_" + fs + "_compare_model_spe_in_predicting_" + sp)
				add_to_w(fin,trpos,tepos)
			fout=path.join(clusdir,"Cluster_tr_given_te_" + algo + "_" + fs + ".csv")
			print_files(w,fout)
			#compare te given tr - Figure 3 shows the cases (SVM,RF)x(FS6,SELECT)
			w={}
			for sp in species:
				trpos,tepos = 0,1
				fin = path.join(clusdir,algo + "_" + fs + "_compare_test_spe_predicted_by_" + sp)
				add_to_w(fin,trpos,tepos)
			fout = path.join(clusdir,"Cluster_te_given_tr_" + algo + "_" + fs + ".csv")
			print_files(w,fout)
	#Summarize ensembles of 24 members - no figures shown in the MS
	for fs in FS24:
		#compare te given tr
		w={}
		for sp in species:
			trpos,tepos = 0,1
			fin = path.join(clusdir,fs + "_compare_test_spe_predicted_by_" + sp)
			add_to_w(fin,trpos,tepos)
		fout = path.join(clusdir,"Cluster_te_given_tr_" + fs + ".csv")
		print_files(w,fout)
		#compare tr given te	
		w={}	
		for sp in species:	
			trpos,tepos = 1,0
			fin = path.join(clusdir,fs + "_compare_model_spe_in_predicting_" + sp)
			add_to_w(fin,trpos,tepos)
		fout=path.join(clusdir,"Cluster_tr_given_te_" + fs,".csv")
		print_files(w,fout)


def main():
	clusdir=path.join(getcwd(),"Clusters")
	summarizeall(clusdir)

if __name__=="main":
	main()
